Overview | Package | Class | Tree | Deprecated | Index | Help
| Xerces 1.2.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.xerces.dom
Class EntityReferenceImpl

    java.lang.Object
      |
      +--org.apache.xerces.dom.NodeImpl
            |
            +--org.apache.xerces.dom.ChildNode
                  |
                  +--org.apache.xerces.dom.ChildAndParentNode
                        |
                        +--org.apache.xerces.dom.EntityReferenceImpl

All Implemented Interfaces:
  java.lang.Cloneable, EntityReference, EventTarget, Node, NodeList, java.io.Serializable

Direct Known Subclasses:
  DeferredEntityReferenceImpl

public class EntityReferenceImpl
extends ChildAndParentNode
implements EntityReference

EntityReference models the XML &entityname; syntax, when used for entities defined by the DOM. Entities hardcoded into XML, such as character entities, should instead have been translated into text by the code which generated the DOM tree.

An XML processor has the alternative of fully expanding Entities into the normal document tree. If it does so, no EntityReference nodes will appear.

Similarly, non-validating XML processors are not required to read or process entity declarations made in the external subset or declared in external parameter entities. Hence, some applications may not make the replacement value available for Parsed Entities of these types.

EntityReference behaves as a read-only node, and the children of the EntityReference (which reflect those of the Entity, and should also be read-only) give its replacement value, if any. They are supposed to automagically stay in synch if the DocumentType is updated with new values for the Entity.

The defined behavior makes efficient storage difficult for the DOM implementor. We can't just look aside to the Entity's definition in the DocumentType since those nodes have the wrong parent (unless we can come up with a clever "imaginary parent" mechanism). We must at least appear to clone those children... which raises the issue of keeping the reference synchronized with its parent. This leads me back to the "cached image of centrally defined data" solution, much as I dislike it.

For now I have decided, since REC-DOM-Level-1-19980818 doesn't cover this in much detail, that synchronization doesn't have to be considered while the user is deep in the tree. That is, if you're looking within one of the EntityReferennce's children and the Entity changes, you won't be informed; instead, you will continue to access the same object -- which may or may not still be part of the tree. This is the same behavior that obtains elsewhere in the DOM if the subtree you're looking at is deleted from its parent, so it's acceptable here. (If it really bothers folks, we could set things up so deleted subtrees are walked and marked invalid, but that's not part of the DOM's defined behavior.)

As a result, only the EntityReference itself has to be aware of changes in the Entity. And it can take advantage of the same structure-change-monitoring code I implemented to support DeepNodeList.

Since:
  PR-DOM-Level-1-19980818.
Version:
See Also:
  Serialized Form

Field Summary
`protected java.lang.String` | `name` Name of Entity referenced

Fields inherited from class org.apache.xerces.dom.ChildAndParentNode
`firstChild, nodeListIndex, nodeListLength, nodeListNode, ownerDocument`

Fields inherited from class org.apache.xerces.dom.ChildNode
`nextSibling, previousSibling`

Fields inherited from class org.apache.xerces.dom.NodeImpl
`ELEMENT_DEFINITION_NODE, FIRSTCHILD, flags, IGNORABLEWS, MUTATION_AGGREGATE, MUTATION_ALL, MUTATION_LOCAL, MUTATION_NONE, MUTATIONEVENTS, OWNED, ownerNode, READONLY, SETVALUE, SPECIFIED, SYNCCHILDREN, SYNCDATA`

Fields inherited from interface org.w3c.dom.Node
`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

Constructor Summary
`EntityReferenceImpl(DocumentImpl ownerDoc, java.lang.String name)` Factory constructor.

Method Summary
`NodeList` | `getChildNodes()` Perform synchronize() before accessing children.
`Node` | `getFirstChild()` Perform synchronize() before accessing children.
`Node` | `getLastChild()` Perform synchronize() before accessing children.
`int` | `getLength()` Query the number of children in the entity definition.
`java.lang.String` | `getNodeName()` Returns the name of the entity referenced
`short` | `getNodeType()` A short integer indicating what type of node this is.
`boolean` | `hasChildNodes()` Returns whether this node has any children.
`Node` | `item(int index)` Returns the node at the given index.
`protected void` | `synchronize()` EntityReference's children are a reflection of those defined in the named Entity.

Methods inherited from class org.apache.xerces.dom.ChildAndParentNode
`cloneNode, getOwnerDocument, insertBefore, normalize, removeChild, replaceChild, setReadOnly, synchronizeChildren, synchronizeChildren`

Methods inherited from class org.apache.xerces.dom.ChildNode
`getNextSibling, getParentNode, getPreviousSibling`

Methods inherited from class org.apache.xerces.dom.NodeImpl
`addEventListener, appendChild, changed, changes, dispatchEvent, getAttributes, getLocalName, getNamespaceURI, getNodeValue, getPrefix, getReadOnly, getUserData, hasAttributes, isSupported, removeEventListener, setNodeValue, setPrefix, setUserData, synchronizeData, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.w3c.dom.Node
`appendChild, cloneNode, getAttributes, getLocalName, getNamespaceURI, getNextSibling, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, hasAttributes, insertBefore, isSupported, normalize, removeChild, replaceChild, setNodeValue, setPrefix`

Field Detail

### name

    protected java.lang.String name

  Name of Entity referenced

Constructor Detail

### EntityReferenceImpl

    public EntityReferenceImpl(DocumentImpl ownerDoc,
                               java.lang.String name)

  Factory constructor.

Method Detail

### getNodeType

    public short getNodeType()

  A short integer indicating what type of node this is. The named constants for this value are defined in the org.w3c.dom.Node interface.
  Specified by:
    `getNodeType` in interface `Node`
  Overrides:
    `getNodeType` in class `NodeImpl`

### getNodeName

    public java.lang.String getNodeName()

  Returns the name of the entity referenced
  Specified by:
    `getNodeName` in interface `Node`
  Overrides:
    `getNodeName` in class `NodeImpl`

### getChildNodes

    public NodeList getChildNodes()

  Perform synchronize() before accessing children.
  Specified by:
    `getChildNodes` in interface `Node`
  Overrides:
    `getChildNodes` in class `ChildAndParentNode`
  Returns:
    org.w3c.dom.NodeList

### getFirstChild

    public Node getFirstChild()

  Perform synchronize() before accessing children.
  Specified by:
    `getFirstChild` in interface `Node`
  Overrides:
    `getFirstChild` in class `ChildAndParentNode`
  Returns:
    org.w3c.dom.NodeList

### getLastChild

    public Node getLastChild()

  Perform synchronize() before accessing children.
  Specified by:
    `getLastChild` in interface `Node`
  Overrides:
    `getLastChild` in class `ChildAndParentNode`
  Returns:
    org.w3c.dom.NodeList

### getLength

    public int getLength()

  Query the number of children in the entity definition. (A bit more work than asking locally, but may be able to avoid or defer building the clone subtree.)
  Overrides:
    `getLength` in class `ChildAndParentNode`
  Returns:
    org.w3c.dom.NodeList

### hasChildNodes

    public boolean hasChildNodes()

  Returns whether this node has any children.
  Specified by:
    `hasChildNodes` in interface `Node`
  Overrides:
    `hasChildNodes` in class `ChildAndParentNode`
  Returns:
    boolean

### item

    public Node item(int index)

  Returns the node at the given index.
  Overrides:
    `item` in class `ChildAndParentNode`
  Following copied from class: `org.apache.xerces.dom.ChildAndParentNode`
  Parameters:
    `Index` - int
  Returns:
    org.w3c.dom.Node

### synchronize

    protected void synchronize()

  EntityReference's children are a reflection of those defined in the named Entity. This method creates them if they haven't been created yet. This doesn't really support editing the Entity though.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Xerces 1.2.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD